Public Member Functions | List of all members
clan::Rectf Class Reference
clanCore Math

2D (left,top,right,bottom) rectangle structure - Float More...

`#include <rect.h>`

Inheritance diagram for clan::Rectf:

## Public Member Functions
| Rectf ()
| Rectf (const Sizex< int > &s)
| Rectf (const Sizex< float > &s)
| Rectf (float new_left, float new_top, float new_right, float new_bottom)
| Rectf (const Pointx< float > &p, const Sizex< float > &size)
| Rectf (const Rectx< int > &rect)
| Rectf (const Rectx< float > &rect)
| Rectf (const Rectx< double > &rect)
| Rectf (float new_left, float new_top, const Sizex< float > &size)
Public Member Functions inherited from clan::Rectx< float >
Rectx< float > & | set_top_left (const Vec2< float > &p)
| Sets the top-left point of the rectangle. More...
Rectx< float > & | set_width (floatwidth)
| Sets the width of the rectangle. More...
Rectx< float > & | set_height (floatheight)
| Sets the height of the rectangle. More...
Rectx< float > & | shrink (const float &new_left, const float &new_top, const float &new_right, const float &new_bottom)
| Shrink the rectangle. More...
Rectx< float > & | shrink (const float &left_right, const float &top_bottom)
| Shrink the rectangle. More...
Rectx< float > & | shrink (const float &shrink)
| Shrink the rectangle. More...
Rectx< float > & | expand (const float &expand_left, const float &expand_top, const float &expand_right, const float &expand_bottom)
| Expand the rectangle. More...
Rectx< float > & | expand (const float &left_and_right, const float &top_and_bottom)
| Expand the rectangle. More...
Rectx< float > & | expand (const float &expand)
| Expand the rectangle. More...
Rectx< float > & | translate (const Vec2< float > &p)
| Translate the rect. More...
Rectx< float > & | translate (const Sizex< float > &p)
| Translate the rect. More...
Rectx< float > & | translate (const Rectx< float > &p)
| Translate the rect by another rect (only uses the left and top coords). More...
Rectx< float > & | translate (floatx, floaty)
| Translate the rect. More...
Rectx< float > & | set_size (const Sizex< float > &size)
| Sets the size of the rectangle, maintaining top/left position. More...
Rectx< float > & | overlap (const Rectx< float > &rect)
| Calculates the intersection of two rectangles. More...
Rectx< float > & | bounding_rect (const Rectx< float > &rect)
| Calculates the bounding rectangle of the rectangles. More...
Rectx< float > & | normalize ()
| Normalize rectangle. More...
Rectx< float > & | apply_alignment (Origin origin, floatx, floaty)
| Applies an origin and offset pair to this rectangle. More...
Rectx< float > & | clip (const Rectx< float > &cr)
| Clip according to the specified clip rectangle. More...
float | get_width () const
| Returns the width of the rectangle. More...
float | get_height () const
| Returns the height of the rectangle. More...
Sizex< float > | get_size () const
| Returns the size of the rectangle. More...
bool | contains (const Vec2< float > &p) const
| Returns true if the rectangle contains the point. More...
Pointx< float > | get_top_left () const
| Returns the top-left point inside the rectangle. More...
Pointx< float > | get_top_right () const
| Returns the top-right point outside the rectangle. More...
Pointx< float > | get_bottom_right () const
| Returns the bottom-right point outside the rectangle. More...
Pointx< float > | get_bottom_left () const
| Returns the bottom-left point outside the rectangle. More...
bool | is_overlapped (const Rectx< float > &r) const
| Returns true if rectangle passed is overlapping or inside this rectangle. More...
bool | is_inside (const Rectx< float > &r) const
| Returns true if rectangle passed is inside this rectangle. More...
Rectx< float > | get_rot_bounds (const Vec2< float > &hotspot, const Angle &angle) const
| Returns another Rectx<Type> containing a rotated version of this one. More...
Rectx< float > | get_rot_bounds (Origin origin, floatx, floaty, const Angle &angle) const
| Returns another Rectx<Type> containing a rotated version of this one. More...
Pointx< float > | get_center () const
| Returns the center point of the rectangle. More...
| Rectx ()
| Constructs an rectangle. More...
| Rectx (const Sizex< float > &s)
| Constructs an rectangle. More...
| Rectx (floatnew_left, floatnew_top, floatnew_right, floatnew_bottom)
| Constructs an rectangle. More...
| Rectx (const Pointx< float > &p, const Sizex< float > &size)
| Constructs an rectangle. More...
| Rectx (floatnew_left, floatnew_top, const Sizex< float > &size)
| Constructs an rectangle. More...
| Rectx (const Rectx< int > &rect)
| Constructs an rectangle. More...
| Rectx (const Rectx< float > &rect)
| Constructs an rectangle. More...
| Rectx (const Rectx< double > &rect)
| Constructs an rectangle. More...
bool | operator== (const Rectx< float > &r) const
| Rect == Rect operator. More...
bool | operator!= (const Rectx< float > &r) const
| Rect != Rect operator. More...

## Additional Inherited Members
Static Public Member Functions inherited from clan::Rectx< float >
static Rectx< float > | xywh (floatx, floaty, floatwidth, floatheight)
static Rectx< float > | ltrb (floatleft, floattop, floatright, floatbottom)
Public Attributes inherited from clan::Rectx< float >
float | left
| X1-coordinate (left point inside the rectangle) More...
float | top
| Y1-coordinate (top point inside the rectangle) More...
float | right
| X2-coordinate (point outside the rectangle) More...
float | bottom
| Y2-coordinate (point outside the rectange) More...

## Detailed Description

2D (left,top,right,bottom) rectangle structure - Float

The documentation for this class was generated from the following file:

- rect.h